Index: projets/BCCCC/src/org/ccc/bcccc/client/panels/EditPanel.java
===================================================================
--- projets/BCCCC/src/org/ccc/bcccc/client/panels/EditPanel.java	(revision 0)
+++ projets/BCCCC/src/org/ccc/bcccc/client/panels/EditPanel.java	(revision 6)
@@ -0,0 +1,331 @@
+/*
+ * Authors: Matthieu Decorde
+ * 
+ * COPYRIGHT 2015 ICAR - CCC
+ * 
+ * This software is free software: you can redistribute it 
+ * and/or modify it under the terms of the GNU General Public
+ * License as published by the Free Software Foundation,
+ * either version 2 of the License, or (at your option) any
+ * later version.
+ * 
+ * This software is distributed in the hope that it will be
+ * useful, but WITHOUT ANY WARRANTY; without even the implied
+ * warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR
+ * PURPOSE. See the GNU General Public License for more
+ * details.
+ * 
+ */
+package org.ccc.bcccc.client.panels;
+
+import java.util.ArrayList;
+
+import org.ccc.bcccc.client.BCCCC;
+import org.ccc.bcccc.client.Services;
+import org.ccc.bcccc.client.areas.DataRecordArea;
+import org.ccc.bcccc.client.areas.DateRecordArea;
+import org.ccc.bcccc.client.areas.DispositifsRecordArea;
+import org.ccc.bcccc.client.areas.DocumentsRecordArea;
+import org.ccc.bcccc.client.areas.IntegerRecordArea;
+import org.ccc.bcccc.client.areas.LongStringRecordArea;
+import org.ccc.bcccc.client.areas.PublicationsRecordArea;
+import org.ccc.bcccc.client.areas.ReportsRecordArea;
+import org.ccc.bcccc.client.areas.StringRecordField;
+import org.ccc.bcccc.shared.K;
+import org.ccc.bcccc.shared.TerrainRecordAndRights;
+
+import com.google.gwt.user.client.History;
+import com.google.gwt.user.client.rpc.AsyncCallback;
+import com.smartgwt.client.types.TitleOrientation;
+import com.smartgwt.client.util.SC;
+import com.smartgwt.client.widgets.form.DynamicForm;
+import com.smartgwt.client.widgets.form.fields.ButtonItem;
+import com.smartgwt.client.widgets.layout.VLayout;
+
+// TODO: Auto-generated Javadoc
+/**
+ * The Class ViewAndEditTerrainRecordPanel.
+ */
+public class EditPanel extends VLayout {
+
+	/** The record. */
+	public TerrainRecordAndRights record;
+
+	/**
+	 * Instantiates a new view and edit terrain record panel.
+	 */
+	public EditPanel() {
+		this.setWidth100();
+		this.setHeight100();
+	}
+
+	/** The init view and edit done. */
+	boolean initViewAndEditDone;
+	
+	/** The view and edit form. */
+	private DynamicForm viewAndEditForm;
+
+	/** The save vae button. */
+	private ButtonItem saveVAEButton;
+	
+	/** The delete vae button. */
+	private ButtonItem deleteVAEButton;
+	
+	/** The validate vae button. */
+	private ButtonItem validateVAEButton;
+
+	/** The name field. */
+	private StringRecordField nameField;
+	
+	/** The project field. */
+	private StringRecordField projectField;
+	
+	/** The description field. */
+	private LongStringRecordArea descriptionField;
+	
+	/** The date field. */
+	private DateRecordArea dateField;
+
+	/** The number of participants field. */
+	private IntegerRecordArea numberOfParticipantsField;
+	
+	/** The participants field. */
+	private StringRecordField personsField;
+	
+	/** The types field. */
+	private StringRecordField typesField;
+	
+	/** The dispositifs field. */
+	private DispositifsRecordArea dispositifsField;
+	
+	/** The data field. */
+	private DataRecordArea dataField;
+	
+	/** The documentation field. */
+	private DocumentsRecordArea documentationField;
+	
+	/** The report field. */
+	private ReportsRecordArea reportField;
+	
+	/** The publication field. */
+	private PublicationsRecordArea publicationField;
+
+	/**
+	 * Inits the.
+	 */
+	public void init() {
+		this.hide();
+		if (!initViewAndEditDone) {
+			initViewAndEditDone = true;
+
+			viewAndEditForm = new DynamicForm();
+
+			saveVAEButton = new ButtonItem("save_record");
+			saveVAEButton.setTitle("Save changes");
+			saveVAEButton.addClickHandler(new com.smartgwt.client.widgets.form.fields.events.ClickHandler() {
+				@Override
+				public void onClick(com.smartgwt.client.widgets.form.fields.events.ClickEvent event) {
+//					final String ID = viewAndEditForm.getValueAsString(K.ID);
+//					if (ID == null || ID.trim().length() == 0) return;
+
+					record.record.setInfoFields(nameField.getValue(), 
+							projectField.getValue(), 
+							dateField.getDate(), 
+							descriptionField.getValue(),
+							"???");
+					
+					record.record.setDetailFields(Integer.parseInt(numberOfParticipantsField.getValue()), 
+							viewAndEditForm.getValueAsString(K.PLACE), 
+							typesField.getValuesAsStringArray(), 
+							new ArrayList<String>(),
+							personsField.getValuesAsStringArray(),
+							dispositifsField.getValues(),
+							documentationField.getValues(), 
+							dataField.getValues(),
+							reportField.getValues(),
+							publicationField.getValues());
+
+					System.out.println("Call updateRecord: "+record.record.uniq_id+", "+record.record);
+					Services.getMain().updateRecord(record.record.uniq_id, null, new AsyncCallback<Boolean>() {
+
+						@Override
+						public void onFailure(Throwable caught) {
+							SC.warn(caught.getMessage());
+							caught.printStackTrace();
+						}
+
+						@Override
+						public void onSuccess(Boolean result) {
+							if (result) {
+								SC.warn("Record '"+record.record.uniq_id+"' saved: "+record.record);
+							} else {
+								SC.warn("Record '"+record.record.uniq_id+"' NOT created.");
+							}
+						}
+					});
+				}
+			});
+
+			deleteVAEButton = new ButtonItem("delete_record");
+			deleteVAEButton.setTitle("Delete record");
+			deleteVAEButton.addClickHandler(new com.smartgwt.client.widgets.form.fields.events.ClickHandler() {
+				@Override
+				public void onClick(com.smartgwt.client.widgets.form.fields.events.ClickEvent event) {
+					Services.getMain().deleteRecord(record.record.uniq_id, new AsyncCallback<Boolean>() {
+						@Override
+						public void onFailure(Throwable caught) {
+							SC.warn("Error: "+caught);
+						}
+
+						@Override
+						public void onSuccess(Boolean result) {
+							if (result) {
+								SC.say("Deleted.");
+								History.newItem(K.BROWSE+"_my");
+							} else {
+								SC.say("NOT Deleted.");
+							}
+						}
+					});
+				}
+			});
+
+			validateVAEButton = new ButtonItem("validate_record");
+			validateVAEButton.setTitle("Validate record");
+			validateVAEButton.addClickHandler(new com.smartgwt.client.widgets.form.fields.events.ClickHandler() {
+				@Override
+				public void onClick(com.smartgwt.client.widgets.form.fields.events.ClickEvent event) {
+					Services.getMain().setValidateRecordValue(record.record.uniq_id, false, new AsyncCallback<Boolean>() {
+						@Override
+						public void onFailure(Throwable caught) {
+							SC.warn("Error: "+caught);
+						}
+
+						@Override
+						public void onSuccess(Boolean result) {
+							SC.say("Validated? "+result);
+						}
+					});
+				}
+			});
+
+			viewAndEditForm.setNumCols(3);
+			viewAndEditForm.setAutoWidth();
+			viewAndEditForm.setItems(deleteVAEButton, validateVAEButton, saveVAEButton);
+			viewAndEditForm.setTitleOrientation(TitleOrientation.LEFT);
+
+			nameField = new StringRecordField(this, "Name", false, true, null);	
+			projectField = new StringRecordField(this, "Project", false, true, null);	
+			descriptionField = new LongStringRecordArea(this, "Description", false, true);
+			dateField = new DateRecordArea(this, "Date", false, true, null);
+			numberOfParticipantsField = new IntegerRecordArea(this, "Number of participants");
+			personsField = new StringRecordField(this, "Participants", true, true, null);
+			String[] typesValues = {"privé", "commerce", "école", "etc."};
+			typesField = new StringRecordField(this, "Types", true, false, typesValues);
+			dispositifsField = new DispositifsRecordArea(this, "Dispositifs");
+			dataField = new DataRecordArea(this,  "Données");
+			documentationField = new DocumentsRecordArea(this, "Documentation");
+			reportField = new ReportsRecordArea(this,  "Rapports");
+			publicationField = new PublicationsRecordArea(this, "Publications");
+		}
+
+		if (BCCCC.doubleClickedRecord != null) { // load record informations
+			System.out.println("Reloading viewAndEdit record... "+BCCCC.doubleClickedRecord);
+			Services.getMain().getRecord(BCCCC.doubleClickedRecord.uniq_id, new AsyncCallback<TerrainRecordAndRights>() {
+				@Override
+				public void onFailure(Throwable caught) {
+					SC.warn("Error: "+caught);
+				}
+
+				@Override
+				public void onSuccess(TerrainRecordAndRights result) {
+
+					if (result == null) {
+						SC.warn("Error: no record found for ID="+BCCCC.doubleClickedRecord);
+						return;
+					}
+					record = result;
+					//record.record.uniq_id = BCCCC.doubleClickedRecord.uniq_id;
+					
+					viewAndEditForm.setCanEdit(result.editable);
+					validateVAEButton.setDisabled(!result.validable);
+					validateVAEButton.setStartRow(false);
+					validateVAEButton.setEndRow(false);
+					deleteVAEButton.setDisabled(!result.deletable);
+					deleteVAEButton.setStartRow(false);
+					deleteVAEButton.setEndRow(false);
+					saveVAEButton.setDisabled(!result.editable);
+					saveVAEButton.setStartRow(false);
+					saveVAEButton.setEndRow(false);
+					
+					addMember(viewAndEditForm);
+					viewAndEditForm.setVisible(result.editable);
+
+					nameField.setCanEdit(record.editable);
+					nameField.setValue(record.record.name);
+					projectField.setCanEdit(record.editable);
+					projectField.setValue(record.record.project);
+					descriptionField.setCanEdit(record.editable);
+					descriptionField.setValue(record.record.short_description);
+					typesField.setCanEdit(record.editable);
+					typesField.setValues(record.record.types);
+					dateField.setCanEdit(record.editable);
+					dateField.setValue(record.record.date);
+					numberOfParticipantsField.setCanEdit(record.editable);
+					numberOfParticipantsField.setValue(record.record.numberOfParticipants);
+					personsField.setCanEdit(record.editable);
+					dispositifsField.setCanEdit(record.editable);
+					dispositifsField.setValues(record.record.dispositifs);
+					dataField.setCanEdit(record.editable);
+					dataField.setDataValues(record.record.supports);
+					documentationField.setCanEdit(record.editable);
+					documentationField.setValues(record.record.documentations);
+					reportField.setCanEdit(record.editable);
+					reportField.setValues(record.record.reports);
+					publicationField.setCanEdit(record.editable);
+					publicationField.setValues(record.record.publications);
+					
+					addMember(viewAndEditForm);
+					addMember(nameField);
+					addMember(projectField);
+					addMember(descriptionField);
+					addMember(dateField);
+					addMember(numberOfParticipantsField);
+					addMember(typesField);
+					addMember(personsField);
+					addMember(dispositifsField);
+					addMember(dataField);
+					addMember(documentationField);
+					addMember(reportField);
+					addMember(publicationField);
+					show();
+				}
+			});
+		} else {
+			this.show();
+		}
+	}
+
+	/**
+	 * To string list.
+	 *
+	 * @param string the string
+	 * @return the string
+	 */
+	protected static String toStringList(String string) {
+		return string.replace("[", "").replace("]", "");
+	}
+
+	/**
+	 * Checks if is record changed.
+	 *
+	 * @return true, if is record changed
+	 */
+	public boolean isRecordChanged() {
+		if (record != null) {
+			return false;
+		} else {
+			return false;
+		}
+	}
+}
Index: projets/BCCCC/src/org/ccc/bcccc/client/GreetingServiceAsync.java
===================================================================
--- projets/BCCCC/src/org/ccc/bcccc/client/GreetingServiceAsync.java	(revision 5)
+++ projets/BCCCC/src/org/ccc/bcccc/client/GreetingServiceAsync.java	(revision 6)
@@ -147,4 +147,6 @@
 	 * @param callback the callback
 	 */
 	void isAdmin(AsyncCallback<Boolean> callback);
+
+	void isOwner(Long ID, AsyncCallback<Boolean> callback);
 }
Index: projets/BCCCC/src/org/ccc/bcccc/client/GreetingService.java
===================================================================
--- projets/BCCCC/src/org/ccc/bcccc/client/GreetingService.java	(revision 5)
+++ projets/BCCCC/src/org/ccc/bcccc/client/GreetingService.java	(revision 6)
@@ -144,4 +144,6 @@
 	 * @return the boolean
 	 */
 	Boolean isAdmin();
+	
+	Boolean isOwner(Long ID);
 }
Index: projets/BCCCC/src/org/ccc/bcccc/server/GreetingServiceImpl.java
===================================================================
--- projets/BCCCC/src/org/ccc/bcccc/server/GreetingServiceImpl.java	(revision 5)
+++ projets/BCCCC/src/org/ccc/bcccc/server/GreetingServiceImpl.java	(revision 6)
@@ -418,6 +418,7 @@
 	 */
 	@Override
 	public Boolean updateRecord(Long ID, TerrainRecord content) {
+		System.out.println("Update record start");
 		log.info("updateRecord: "+ID+" "+content);
 		if (isLogged()) {
 			String session = this.getThreadLocalRequest().getSession().getId();
@@ -437,7 +438,7 @@
 						log.warning("updateRecord: record needs to be validatd before: "+ID);
 						return false;
 					}
-					record.setDetailFields(content.numberOfParticipants, content.place, content.types, content.keywords, content.dispositifs, content.documentations, content.supports, content.reports, content.publications);
+					record.setDetailFields(content.numberOfParticipants, content.place, content.types, content.keywords, content.persons, content.dispositifs, content.documentations, content.supports, content.reports, content.publications);
 					record.setInfoFields(content.name, content.project, content.date, content.short_description, content.user);
 					return records.save(record);
 
@@ -494,4 +495,31 @@
 			return false;
 		}
 	}
+
+	@Override
+	public Boolean isOwner(Long ID) {
+		log.info("isOwner: "+ID);
+		if (isLogged()) {
+			String session = this.getThreadLocalRequest().getSession().getId();
+			String user = connectedUsers.get(session);
+
+			log.info("isOwner: "+user);
+
+			if (!records.containsKey(ID)) {
+				log.warning("isOwner: record does not exists "+ID);
+				return false;
+			} else {
+				if (records.isRecordSetToUser(user, ID) || user.equals(ConfigDB.getAdmin())) {
+					log.info("isOwner: ok "+ID);
+					return true;
+				} else {
+					log.warning("isOwner: user has not the rigths "+user);
+					return false;
+				}
+			}
+		} else {
+			log.info("isOwner: user is NOT logged.");
+			return false;
+		}
+	}
 }
Index: projets/BCCCC/src/org/ccc/bcccc/shared/TerrainRecord.java
===================================================================
--- projets/BCCCC/src/org/ccc/bcccc/shared/TerrainRecord.java	(revision 5)
+++ projets/BCCCC/src/org/ccc/bcccc/shared/TerrainRecord.java	(revision 6)
@@ -28,61 +28,64 @@
  * The Class TerrainRecord.
  */
 public class TerrainRecord implements Serializable {
-	
+
 	/** The Constant serialVersionUID. */
 	private static final long serialVersionUID = 9112560460069520009L;
 
 	/** The uniq_id. */
 	// main info fields
 	public long uniq_id = 0;
-	
+
 	/** The name. */
 	public String name = "";
-	
+
 	/** The project. */
 	public String project = "";
-	
+
 	/** The date. */
 	public Date date = new Date();
-	
+
 	/** The year. */
 	public int year = 0;
-	
+
 	/** The short_description. */
 	public String short_description = "";
-	
+
 	/** The user. */
 	// manage fields
 	public String user = "";
-	
+
 	/** The must be validated. */
 	public boolean mustBeValidated = true;
-	
+
 	/** The number of participants. */
 	// detail fields
 	public int numberOfParticipants = 0;
-	
+
 	/** The place. */
 	public String place = "";
-	
+
 	/** The types. */
 	public List<String> types = new ArrayList<String>();
-	
+
 	/** The keywords. */
 	public List<String> keywords = new ArrayList<String>();
-	
+
+	/** The persons. */
+	public List<String> persons = new ArrayList<String>();
+
 	/** The dispositifs. */
 	public List<Dispositif> dispositifs = new ArrayList<Dispositif>();
-	
+
 	/** The documentations. */
 	public List<DocumentUnit> documentations = new ArrayList<DocumentUnit>();
-	
+
 	/** The supports. */
 	public List<Data> supports = new ArrayList<Data>();
-	
+
 	/** The reports. */
 	public List<Report> reports = new ArrayList<Report>();
-	
+
 	/** The publications. */
 	public List<Publication> publications = new ArrayList<Publication>();
 
@@ -90,7 +93,7 @@
 	 * Instantiates a new terrain record.
 	 */
 	public TerrainRecord() {}
-	
+
 	/**
 	 * Sets the info fields.
 	 *
@@ -113,7 +116,7 @@
 		this.user = user;
 		return this;
 	}
-	
+
 	/**
 	 * Sets the detail fields.
 	 *
@@ -129,13 +132,14 @@
 	 * @return the terrain record
 	 */
 	public TerrainRecord setDetailFields(int numberOfParticipants, String place, 
-			List<String> types, List<String> keywords, 
+			List<String> types, List<String> keywords, List<String> persons, 
 			List<Dispositif> dispositifs, List<DocumentUnit> documentations, 
 			List<Data> supports, List<Report> reports, List<Publication> publications) {
 		this.numberOfParticipants = numberOfParticipants;
 		this.place = place;
 		this.types = types;
 		this.keywords = keywords;
+		this.persons = persons;
 		this.dispositifs = dispositifs;
 		this.documentations = documentations;
 		this.supports = supports;
@@ -143,11 +147,34 @@
 		this.publications = publications;
 		return this;
 	}
-	
+
 	/* (non-Javadoc)
 	 * @see java.lang.Object#toString()
 	 */
 	public String toString() {
-		return uniq_id+"="+name+" "+project+" "+user+" "+mustBeValidated+" "+date+" "+year+" "+place+" "+numberOfParticipants+" "+types+" "+keywords+" "+dispositifs+" "+supports+" "+documentations+" "+short_description;
+		return uniq_id+"="+name+" "+project+" "+user+" "+mustBeValidated+" "+date+" "+year+" "+place+" "+numberOfParticipants+" "+types+" "+keywords+" "+" "+persons+" "+dispositifs+" "+supports+" "+documentations+" "+short_description;
 	}
+
+	/* (non-Javadoc)
+	 * @see java.lang.Object#toString()
+	 */
+	public String toHTML() {
+		return "<h3>"+name+"</h3>\n" +
+				"<h3>Informations</h3>\n" +
+				"<ul>"+
+				"<li>Project: "+project+"</li>\n" +
+				"<li>Owner: "+user+"</li>\n" +
+				"<li>Year: "+year+"</li>\n" +
+				"<li>Place: "+place+"</li>\n" +
+				"<li>Number of participants: "+numberOfParticipants+"</li>" +
+				"</ul>" +
+				"<h3>Details</h3>\n" +
+				"<p>Types: "+types+"</p>\n" +
+				"<p>Persons: "+persons+"</p>\n" +
+				"<p>Dispositifs: "+dispositifs+"</p>\n" +
+				"<p>Equipments: "+supports+"</p>\n" +
+				"<p>Documentation: "+documentations+"<p>\n" +
+				"<h3>Description</h3>\n" +
+				"<p>"+short_description;
+	}
 }
Index: projets/BCCCC/src/org/ccc/bcccc/shared/K.java
===================================================================
--- projets/BCCCC/src/org/ccc/bcccc/shared/K.java	(revision 5)
+++ projets/BCCCC/src/org/ccc/bcccc/shared/K.java	(revision 6)
@@ -37,8 +37,10 @@
 	public static final String NEWRECORD = "new";
 	
 	/** The Constant VIEWEDITRECORD. */
-	public static final String VIEWEDITRECORD = "viewedit";
+	public static final String EDITRECORD = "edit";
 	
+	public static final String VIEWRECORD = "view";
+	
 	/** The Constant ID. */
 	public static final String ID = "id";
 	
Index: projets/BCCCC/src/org/ccc/bcccc/shared/Dispositif.java
===================================================================
--- projets/BCCCC/src/org/ccc/bcccc/shared/Dispositif.java	(revision 5)
+++ projets/BCCCC/src/org/ccc/bcccc/shared/Dispositif.java	(revision 6)
@@ -25,10 +25,12 @@
  * The Class Dispositif.
  */
 public class Dispositif implements Serializable {
+	
+	/**
+	 * 
+	 */
+	private static final long serialVersionUID = 623201999995138355L;
 
-	/** The Constant serialVersionUID. */
-	private static final long serialVersionUID = 2954507863339852772L;
-	
 	/** The type. */
 	public String type = "";
 	
